//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "EnumEg2U.h"
#include <TypInfo.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //Get RTTI for the BorderStyle property
  PPropInfo PropInfo =
    GetPropInfo((PTypeInfo)ClassInfo(), "BorderStyle");
    //Could alternatively use this syntax
    //GetPropInfo(__typeinfo(TForm), "BorderStyle");
  if (PropInfo)
  {
    PTypeInfo TypeInfo = *(PropInfo->PropType);
    //Store current BorderStyle
    String OldStyle = GetEnumName(TypeInfo, int(BorderStyle));
    //Now change BorderStyle to different
    //value, specified as a string
    const String NewStyle = "bsToolWindow";
    BorderStyle = TFormBorderStyle(GetEnumValue(TypeInfo, NewStyle));
    //Write information about what happened on the caption bar
    Caption = Format(
      "At design time, this form's border style was %s, now it is %s",
      ARRAYOFCONST((OldStyle, NewStyle)));
  }
}
//---------------------------------------------------------------------------
